package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import flashx.textLayout.formats.BackgroundColor;
	import flashx.textLayout.operations.RedoOperation;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		private var timeleft:FlxText;
		
		private var t1:FlxText;
		private var t2:FlxText;
		private var t3:FlxText;
		
		
		
		[Embed(source="data/incorrect.mp3")]
		public static var SndIncorrect:Class;
		[Embed(source="data/ending.mp3")]
		public static var SndEnding:Class;
		[Embed(source="data/correct.mp3")]
		public static var SndCorrect:Class;
		
		private var tsource:FlxText;
		
		private var scoretxt:FlxText;
		
		private var t:Number;
		
		public var answer:int;
		override public function create():void
		{
			TitleState.curscore=0;
			t=60;
			timeleft = new FlxText(5,5,FlxG.width,"Time : ");	
			timeleft.size=16;
			timeleft.alignment="center";		
			add(timeleft);

			t1 = new FlxText(5,100,FlxG.width,"cat");
			t1.size=16;
			add(t1);
			
			t2 = new FlxText(5,120,FlxG.width,"dog");
			t2.size=16;
			add(t2);
			
			
			t3 = new FlxText(5,140,FlxG.width,"bunny");
			t3.size=16;
			add(t3);
			
			
			tsource = new FlxText(5,160,FlxG.width,"claws");
			tsource.size=16;
			tsource.alignment="center";
			add(tsource);
			
			
			scoretxt = new FlxText(5,70,FlxG.width,"score : 0");
			scoretxt.size=16;
			scoretxt.alignment="center";
			add(scoretxt);
			
			
			hiscoretxt = new FlxText(5,240,FlxG.width,"highscore : " + TitleState.highscore);
			hiscoretxt.size=16;
			hiscoretxt.alignment="left";
			add(hiscoretxt);
			
			SetQuestion();
		}
		private var hiscoretxt:FlxText;
		
		private function SetQuestion():void
		{
			trace(answer);
			scoretxt.text = "score : "+TitleState.curscore;
			var i1:uint = int(Math.random()*(DataClass.dat.length/3));
			var i2:uint = int(Math.random()*(DataClass.dat.length/3))+int(DataClass.dat.length/3);
			var i3:uint = int(Math.random()*(DataClass.dat.length/3))+2*(DataClass.dat.length/3);
			if (i1>DataClass.dat.length)
			{
				i1 = Math.random()*DataClass.dat.length;
			}
			if (i2>DataClass.dat.length)
			{
				i2 = Math.random()*DataClass.dat.length;
			}
			if (i3>DataClass.dat.length)
			{
				i3 = Math.random()*DataClass.dat.length;
			}
			i1/=2;
			i2/=2;
			i3/=2;
			t1.text="1 - " +DataClass.dat[i1*2+1];
			t2.text="2 - " + DataClass.dat[i2*2+1];
			t3.text="3 - " + DataClass.dat[i3*2+1];
			
			answer = Math.random()*3;
			
			if (answer==0)
			{
				tsource.text=DataClass.dat[i1*2];
			}
			else if (answer==1)
			{
				tsource.text=DataClass.dat[i2*2];			
			}
			else
			{
				tsource.text=DataClass.dat[i3*2];							
			}
		}
		
		private var ended:Boolean=false;
		override public function update():void
		{
			t-=FlxG.elapsed;
			
			if (t<0)
			{
				if (ended==false)
				{
					ended=true;					
					FlxG.play(SndEnding);	
				}
				if (TitleState.curscore>TitleState.highscore)
				{
					TitleState.highscore=TitleState.curscore;
					TitleState.ApplyHighScore();
					hiscoretxt.text = "hiscore : " + TitleState.highscore;
				}
				timeleft.text = "Time : 0";
				//END STATE
				t1.visible=false;
				t2.visible=false;
				t3.visible=false;
				tsource.text="CLICK TO RETRY";		
				
				if (FlxG.mouse.justPressed())
				{
					FlxG.play(GameState.SndCorrect).survive=true;	
					FlxG.state = new GameState();
				}
			}
			else
			{
				timeleft.text = "Time : " + int(t);	
				if (FlxG.keys.justPressed("ONE"))
				{
					if (0==answer)
					{
						TitleState.curscore+=10;
						FlxG.play(SndCorrect);
					}
					else
					{
						TitleState.curscore-=6;		
						FlxG.play(SndIncorrect);					
					}
					SetQuestion();
				}
				else if (FlxG.keys.justPressed("TWO"))
				{
					if (1==answer)
					{
						TitleState.curscore+=10;
						FlxG.play(SndCorrect);
					}
					else
					{
						TitleState.curscore-=6;	
						FlxG.play(SndIncorrect);						
					}
					SetQuestion();
					
				}
				else if (FlxG.keys.justPressed("THREE"))
				{
					if (2==answer)
					{
						TitleState.curscore+=10;
						FlxG.play(SndCorrect);
					}
					else
					{
						TitleState.curscore-=6;		
						FlxG.play(SndIncorrect);				
					}
					SetQuestion();
					
				}
			}
		}
	}
}